"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ora_1 = __importDefault(require("ora"));
var generators_1 = require("./generators");
var builders_1 = require("./builders");
var shared_template_1 = require("./templates/shared.template");
var scalars_store_1 = __importDefault(require("./store/scalars.store"));
var templates_1 = require("./templates");
var generatedInterfaces = {
    METHODS: '',
    OBJECT: [],
    ENUM: [],
    METHODS_ARGS: [],
    QUERIES: '',
    HOOKS: '',
};
var transpile = ora_1.default('🔄 Transpiling GraphQL schema to Typescript interfaces');
exports.generate = function (schema, prefix, suffix, customScalars, codegenMethods, codegenHooks, codegenTemplates) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, generatedEnums, generatedTypes, generatedMethodsArgs, oraMethods, methods, e_1, oraMethods, methods, e_2, methods, e_3, e_4, signature, imports, modelsTemplate;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                if (customScalars) {
                    scalars_store_1.default.addScalars(customScalars);
                }
                transpile.start();
                _b.label = 1;
            case 1:
                _b.trys.push([1, 14, , 15]);
                _a = generators_1.generateInterfaces(schema, prefix, suffix), generatedEnums = _a.generatedEnums, generatedTypes = _a.generatedTypes;
                generatedMethodsArgs = generators_1.generateMethodsArgsTypes(schema, prefix, suffix);
                generatedInterfaces.OBJECT = generatedTypes;
                generatedInterfaces.ENUM = generatedEnums;
                generatedInterfaces.METHODS_ARGS = generatedMethodsArgs;
                if (!codegenMethods) return [3, 5];
                oraMethods = ora_1.default('Generating queries and mutations...').start();
                _b.label = 2;
            case 2:
                _b.trys.push([2, 4, , 5]);
                return [4, builders_1.createMethods({
                        schema: schema,
                        prefix: prefix,
                        suffix: suffix,
                        mode: 'methods',
                    })];
            case 3:
                methods = _b.sent();
                generatedInterfaces.METHODS = methods;
                oraMethods.succeed('🧬 Queries and mutations successfully generated');
                return [3, 5];
            case 4:
                e_1 = _b.sent();
                oraMethods.fail('Methods generation failed');
                return [2, Promise.reject(e_1)];
            case 5:
                if (!codegenHooks) return [3, 9];
                oraMethods = ora_1.default('Generating React hooks...').start();
                _b.label = 6;
            case 6:
                _b.trys.push([6, 8, , 9]);
                return [4, builders_1.createMethods({
                        schema: schema,
                        prefix: prefix,
                        suffix: suffix,
                        mode: 'hooks',
                    })];
            case 7:
                methods = _b.sent();
                generatedInterfaces.HOOKS = methods;
                oraMethods.succeed('⚛️  React Hooks successfully generated');
                return [3, 9];
            case 8:
                e_2 = _b.sent();
                oraMethods.fail('Hooks generation failed');
                return [2, Promise.reject(e_2)];
            case 9:
                if (!codegenTemplates) return [3, 13];
                _b.label = 10;
            case 10:
                _b.trys.push([10, 12, , 13]);
                return [4, builders_1.createMethods({ schema: schema, prefix: prefix, suffix: suffix, mode: 'template' })];
            case 11:
                methods = _b.sent();
                generatedInterfaces.QUERIES = methods;
                return [3, 13];
            case 12:
                e_3 = _b.sent();
                return [2, Promise.reject(e_3)];
            case 13: return [3, 15];
            case 14:
                e_4 = _b.sent();
                transpile.fail('Transpiling failed');
                return [2, Promise.reject(e_4)];
            case 15:
                transpile.succeed("\uD83D\uDCDD Schema transpiled to Typescript");
                signature = shared_template_1.sharedTemplate;
                imports = templates_1.defineImports({
                    codegenHooks: !!codegenHooks,
                    codegenMethods: !!codegenMethods,
                    codegenTemplates: !!codegenTemplates,
                });
                modelsTemplate = "\n      " + signature + "\n\n      " + generatedInterfaces.OBJECT.join('\n') + "\n      " + generatedInterfaces.ENUM.join('\n') + "\n      " + generatedInterfaces.METHODS_ARGS.join('\n') + "\n      " + imports + "\n      " + generatedInterfaces.METHODS + "\n      " + generatedInterfaces.HOOKS + "\n      " + generatedInterfaces.QUERIES + "\n    ";
                return [2, modelsTemplate];
        }
    });
}); };
