"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var methods_generator_1 = require("./methods.generator");
var utilities_1 = require("../utilities");
var types_generator_1 = require("./types.generator");
var query_generator_1 = require("./query.generator");
function capitalize(string) {
    return string.charAt(0).toUpperCase() + string.slice(1);
}
exports.createApolloHook = function (_a) {
    var field = _a.field, ObjectTypes = _a.ObjectTypes, prefix = _a.prefix, suffix = _a.suffix, type = _a.type, renderedFragmentInner = _a.renderedFragmentInner;
    var hasArgs = field.args.length > 0;
    var methodName = field.name;
    var methodArgsType = methods_generator_1.createMethodsArgs(field, prefix, suffix).methodArgsType;
    var isScalar = utilities_1.evaluateType(field).isScalar;
    var returnedTypeDisplay = types_generator_1.getOneTSTypeDisplay({
        field: field,
        prefix: prefix,
        suffix: suffix,
    });
    var Query = query_generator_1.queryBuilder({
        field: field,
        isScalar: isScalar,
        prefix: prefix,
        suffix: suffix,
        renderedFragmentInner: renderedFragmentInner,
        type: type,
    });
    var TOptions = "{" + methodName + ": " + returnedTypeDisplay + "}" + (hasArgs ? ', ' + methodArgsType : '');
    var useHookOutput = '';
    if (type.little === 'query') {
        useHookOutput = "\n      return use" + type.high + "<" + TOptions + ">(" + type.little + ", options);";
    }
    else {
        useHookOutput = "return use" + type.high + "<" + TOptions + ">(" + type.little + ", options);";
    }
    if (isScalar) {
        return "\n    " + (field.description ? "/** " + field.description + " */" : '') + "\n    use" + capitalize(field.name) + "(options?: " + type.high + "HookOptions<" + TOptions + ">)   {\n      const " + type.little + " = " + Query + "\n      " + useHookOutput + "\n    },";
    }
    else {
        return "\n    " + (field.description ? "/** " + field.description + " */" : '') + "\n    use" + capitalize(field.name) + "(fragment: string | DocumentNode, options?: " + type.high + "HookOptions<" + TOptions + ">) {\n      const { isString, isFragment, fragmentName } = guessFragmentType(fragment);\n      const " + type.little + " = " + Query + "\n\n      " + useHookOutput + "\n    }\n  ,";
    }
};
