"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var types_generator_1 = require("./types.generator");
var typesToParse = ['OBJECT', 'INPUT_OBJECT', 'INTERFACE'];
function generateInterfaces(schema, prefix, suffix) {
    var schemaTypes = schema.__schema.types;
    var generatedTypes = [];
    var generatedEnums = [];
    schemaTypes.forEach(function (item) {
        if (!/^_{1,2}/.test(item.name)) {
            if (typesToParse.includes(item.kind)) {
                var generatedInterface = types_generator_1.getObjectTSInterfaces(item, prefix, suffix);
                generatedTypes.push(generatedInterface);
            }
            else if (item.kind === 'ENUM') {
                var enumTypes = types_generator_1.generateEnumType(item, prefix, suffix);
                generatedEnums.push(enumTypes);
            }
        }
    });
    return {
        generatedTypes: generatedTypes,
        generatedEnums: generatedEnums,
    };
}
exports.generateInterfaces = generateInterfaces;
function generateMethodsArgsTypes(schema, prefix, suffix) {
    var _a, _b, _c, _d, _e, _f;
    var QueryType = (_a = schema.__schema.queryType) === null || _a === void 0 ? void 0 : _a.name;
    var MutationType = (_b = schema.__schema.mutationType) === null || _b === void 0 ? void 0 : _b.name;
    var listQueries = (_d = (_c = schema.__schema.types.find(function (f) { return f.name === QueryType; })) === null || _c === void 0 ? void 0 : _c.fields, (_d !== null && _d !== void 0 ? _d : []));
    var listMutations = [];
    var generatedMethodsArgs = [];
    if (MutationType) {
        listMutations = (_f = (_e = schema.__schema.types.find(function (f) { return f.name === MutationType; })) === null || _e === void 0 ? void 0 : _e.fields, (_f !== null && _f !== void 0 ? _f : []));
    }
    __spread(listQueries, listMutations).forEach(function (item) {
        if (!/^_{1,2}/.test(item.name)) {
            var generatedInterface = types_generator_1.getQueriesArgsTSInterfaces(item, prefix, suffix);
            generatedMethodsArgs.push(generatedInterface);
        }
    });
    return generatedMethodsArgs;
}
exports.generateMethodsArgsTypes = generateMethodsArgsTypes;
